
#ifndef __LCD_2x16_H_
#define __LCD_2x16_H_

#include "LPC17xx.h"
#include "lpc_types.h"


#ifdef __cplusplus
extern "C"
{
#endif


//****************************************//*
//****************************************//*
#define LCD_FIRST_ROW           0x80 //*
#define LCD_SECOND_ROW          0xC0 //*
#define LCD_THIRD_ROW           0x94 //*
#define LCD_FOURTH_ROW          0xD4 //*
#define LCD_CLEAR               0x01 //*
#define LCD_RETURN_HOME         0x02 //*
#define LCD_DIRECTION           0x06 //*
#define LCD_CURSOR_OFF          0x0C //*
#define LCD_UNDERLINE_ON        0x0E //*
#define LCD_BLINK_CURSOR_ON     0x0F //*
#define LCD_MOVE_CURSOR_LEFT    0x10 //*
#define LCD_MOVE_CURSOR_RIGHT   0x14 //*
#define LCD_TURN_OFF            0x00 //*
#define LCD_TURN_ON             0x08 //*
#define LCD_SHIFT_LEFT          0x18 //*
#define LCD_SHIFT_RIGHT         0x1C //*
#define LCD_CONTROLLER          0x33 //*
#define LCD_SET_4BIT_MODE       0x32 //*
#define LCD_FOR_2LINE           0x28 //*
//****************************************//*
//****************************************//*

#define TRUE 1
#define FALSE 0

#define LINE1 0x80
#define LINE2 0xC0

#define CONTROL_REG 0x00
#define DATA_REG    0x01

void delay(unsigned int count);
void init_lcd(void);
void lcd_putstring(char *string);
void lcd_putstring16(unsigned char line, char *string);
void lcd_clear(void);
int lcd_gotoxy(unsigned char x, unsigned char y);
void lcd_putchar(unsigned char c);
void Lcd_Out(char *str_out , unsigned char P, unsigned char L);



#endif
