

/*Author: Jesus Martin Palomino Velezquez
Title:Thermomether with lpc1769 and lm35 */


#ifdef __USE_CMSIS
#include "LPC17xx.h"
#include "lpc17xx_gpio.h"
#include "lpc17xx_pinsel.h"
#include "lpc17xx_timer.h"
#include "lpc17xx_adc.h"
#include "lcd_2x16.h"
#include "Conversions.h"
#endif

#include <cr_section_macros.h>
#include <NXP/crp.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

//define
#define ms 1000



void temp_celsius(void);
void temp_fahrenheit(void);

__CRP const unsigned int CRP_WORD = CRP_NO_CRP ;


uint16_t ADC_READ=0;

int main(void) {



	//ADC pin select
	PINSEL_CFG_Type PINSELCfg;
	PINSELCfg.Portnum 	= 	PINSEL_PORT_0;
	PINSELCfg.Funcnum 	= 	PINSEL_FUNC_1;
	PINSELCfg.Pinnum 	=	PINSEL_PIN_23;
	PINSEL_ConfigPin(&PINSELCfg);

	//ADC -> 12 bits
	ADC_Init(LPC_ADC,200000);
	ADC_ChannelCmd(LPC_ADC,0,ENABLE);
	ADC_BurstCmd(LPC_ADC,ENABLE);

	init_lcd();
	lcd_clear();


	Lcd_Out("JM_PAlOMINO",0,0);
	Lcd_Out("MONTERREY_MEX",1,0);
	Timer0_Wait(2000,ms);
	lcd_clear();
	Lcd_Out("Thermometer",0,1);


	for(;;) {

	ADC_READ= ADC_ChannelGetData(LPC_ADC,ADC_CHANNEL_0);
	Timer0_Wait(10,ms);
    temp_celsius();
  	temp_fahrenheit();
  	Timer0_Wait(1000,ms);
  	/*Lcd_Out("                ",1,0);*/ //optional. Clear below before put the values in the lcd 2x16;
                                         //this is done to avoid unwanted numbers
  }

return 0 ; }

void temp_celsius(void){

float celsius;
char txt[5],sym[1];
sym[0]=223;


       celsius=(ADC_READ)*0.120879; // (3.3/4095)*(1.5)*(100)
	   Float_to_Str(celsius, txt, 2);
	   Lcd_Out(txt,1,0);
	   Lcd_Out(sym,1,5);
	   Lcd_Out("C",1,6);

}

void temp_fahrenheit(void){

float fahrenheit;
char txt[6],sym[1];

sym[0]=223;

       fahrenheit=(ADC_READ)*0.120879; // (3.3/4095)*(1.5)*(100)
       fahrenheit=(fahrenheit*1.8)+32;
	   Float_to_Str(fahrenheit, txt, 2);
	   Lcd_Out(txt,1,8);
	   Lcd_Out(sym,1,14);
	   Lcd_Out("F",1,15);

}

